;TIP1054.LSP:  LASSO.LSP     Bold Text     (C)1994, John K. Sherman

(defun C:LASSO (/ tb ll ur ul lr ANS BLNK CE CK1 CK2 CK3 ETYP
      FL1 L1 L2 LAY LEN1 N1 N1X ORF OSM OTX OTXZ PT1
   PT2 PT3 SNP SS1 SS1E SS1L TLR TXSZ UCSO W WUCS)
   (defun *ERROR* (st)
      (princ "error: ")
      (setq OLDERR *error*)
      (command "CMDECHO" CE)
      (setvar "CLAYER" LAY)
      (setvar "OSMODE" OSM)
      (setvar "SNAPMODE" SNP)
      (setvar "TEXTSIZE" OTXZ)
      (command "ucs" "p")
      (princ st)
      (princ)
   )

   ;  (setq *ERROR* nil)
   ;; Remove above semicolon to disable error checking

   ;; ---- SET VARIABLES ----
   (setq CE (getvar "CMDECHO")
      LAY (getvar "CLAYER")
      OSM (getvar "OSMODE")
      OTXZ (getvar "TEXTSIZE")
   SNP (getvar "SNAPMODE"))
   (setvar "CMDECHO" 0)
   (setvar "OSMODE" 0)
   (setvar "SNAPMODE" 0)
   ; ---- UCS ----
   (setq UCSO (getvar "UCSORG"))
   (setq WUCS (getvar "WORLDUCS"))
   (if (= WUCS 0) (command ".UCS" "w"))
   ; ---- PICK LINE ----
   (setq SS1 (car (entsel "Select line of text: ")))
   (command "ucs" "Entity" SS1)
   (setq ETYP (cdr (assoc 0 (entget SS1))))
   ; ---- TEXTSTYLES LOADED ? ----
   (if (not (tblsearch "STYLE" "ROMANS"))
      (progn
         (setq FL1 "No")
         (princ "\nTextstyle ROMANS not loaded. Load ROMANS and try again. ")
      )
   )
   (if (not (tblsearch "STYLE" "ROMANT"))
      (progn
         (setq FL1 "No")
         (princ "\nTextstyle ROMANT not loaded. Load ROMANT and try again. ")
      )
   )
   (terpri)
   ; ---- MAIN CODE ----
   (if (and (= FL1 "No"))
      SS1                          ;Quits if both TEXTSTYLES not loaded
      (progn
         (setq SS1E (entget SS1)
            TLR (cdr (assoc 8 SS1E))
         ORF (cdr (assoc 7 SS1E))) ;keep CK2 in original font
         (if (tblsearch "LAYER" TLR)
            (command "layer" "s" TLR "")  ;keep text on original layer
         )
         (setq TXSZ (cdr (assoc 40 SS1E))
            PT1 (cdr (assoc 10 SS1E))
            OTX (cdr (assoc 1 SS1E))
            SS1L (strlen OTX)
            TB (textbox (list (cons -1 SS1)))
            LL (car TB)
            UR (cadr TB)
            UL (list (car LL) (cadr UR))
            LR (list (car UR) (cadr LL))
            L1 (distance LL LR)
         PT2 (list (+ (car PT1) (* 10 TXSZ)) (+ (cadr PT1) TXSZ)))
         (setq PT3 (getcorner LL "\nLasso some text: "))
         (terpri)
         (command "ucs" "p")
         (setq L2 (- (car PT3) (car LL))
            W (/ L1 SS1L)
            N1 (/ L2 W)
            N1X (fix (/ L2 W))
         REM1 (rem N1 N1X))
         (if (> REM1 0.5)
            (setq N1X (1+ N1X))
         )
         (setq CK1 (substr OTX 1 N1X))
         ; ---- BLANK SPACES ----
         (defun blank ()
            (setq BLNK " ")
            (repeat (- N1X 1)
               (setq BLNK (strcat BLNK " "))
            )
         )
         (setq LEN1 (strlen CK1))
         (setq CK2 (substr OTX (+ LEN1 1) (- SS1L LEN1)))
         (princ "CK1 = ")
         (princ CK1)
         (princ "  CK2 = ")
         (princ CK2)
         (terpri)
         (initget 0 "Y N")                       ;accept null response
         (setq ANS (getkword "Is this correct? <Y>/N "));check lasso contents
         (if (= ANS nil)                         ;ENTER continues
            (progn                               ;quits if N or CANCEL
               (command "erase" "c" PT1 PT2 "")  ;erase original text
               (blank)                           ;create blank spaces
               (setq CK3 (strcat BLNK CK2))      ;combine 
               (command ".TEXT" "S" "ROMANT" PT1 TXSZ "0" CK1) ;replace text
               (command ".TEXT" "S" ORF PT1 TXSZ "0" CK3)      ;replace text
            )
         )
      )
   )
   (if (= WUCS 0)
      (command ".UCS" "origin" UCSO)              ;restore UCSORG
   )
   (setvar "CMDECHO" CE)
   (setvar "CLAYER" LAY)
   (setq *error* OLDERR)
   (setvar "OSMODE" OSM)
   (setvar "SNAPMODE" SNP)
   (setvar "TEXTSIZE" OTXZ)
   (princ)                                        ;exit cleanly
) ;end lasso.lsp




